package extensions;

import br.ufpe.abaco.compiler.*;


class ActionsSequence extends AtomicTerm {

  Term actions[];

  ActionsSequence(Term left,Term right) {
    int size = 0;
    int c;
    if (left instanceof ActionsSequence)
      size += ((ActionsSequence)left).actions.length;
    else 
      size++;
    if (right instanceof ActionsSequence)
      size += ((ActionsSequence)right).actions.length;
    else 
      size++;

    actions = new Term[size];
    size = 0;

    if (left instanceof ActionsSequence) {
      ActionsSequence a = (ActionsSequence)left;
      for (c=0;c<a.actions.length;c++)
	actions[size++] = a.actions[c];
    }
    else 
      actions[size++] = left;

    if (right instanceof ActionsSequence) {
      ActionsSequence a = (ActionsSequence)right;
      for (c=0;c<a.actions.length;c++)
	actions[size++] = a.actions[c];
    }
    else 
      actions[size++] = right;
  }

  public String toString() {
    StringBuffer resul = new StringBuffer();
    for (int c=0;c<actions.length;c++) {
      if (c>0)
	resul.append("AND THEN\n");
      resul.append("| ");
      resul.append(actions[c]);
      resul.append("\n");
    }
    return resul.toString();
  }

  
}
