
package Spec;

import br.ufpe.abaco.compiler.*;

public class StandardOperators {

    CompiledSpecification spec;
    Sort dataSort;
    Sort datumSort;

    Operator emptyTupleOp;
    Operator concatOp;
    Operator mapofOp;
    Operator setofOp;

    public StandardOperators(CompiledSpecification s) {
	spec = s;
	datumSort = spec.getSort("datum");
	dataSort = spec.getSort("data");
	emptyTupleOp = s.getOperator("( )");
	concatOp = s.getOperator("( _ , _ )");
	mapofOp = s.getOperator("map of _ to _");
	setofOp = s.getOperator("set of _");
    }

  boolean isData(Term t) {
    return spec.isSubSort(t,dataSort);
  }

}
